:-use_module(mini_nat).

:- block fact(-,-).
fact(N, F) :-
        {N = 0, F = 1}.
fact(N, F) :-
        {N >= 1, N1 = N-1},
        {F = N*F1},
        fact(N1, F1).


proba(F0, Ns, T) :-
	call({F=F0}),
	statistics(runtime, _),
	findall(N, fact(N, F), Ns),
	statistics(runtime, [_,T]).


end_of_file.

| ?- proba(1, Ns, T).
T = 0,
Ns = [0,1] ? 
yes
| ?- proba(6, Ns, T).
T = 0,
Ns = [3] ? 
yes
| ?- proba(24, Ns, T).
T = 10,
Ns = [4] ? 
yes
| ?- proba(120, Ns, T).
T = 300,
Ns = [5] ? 
yes
| ?- proba(720, Ns, T).
T = 52210,
Ns = [6] ? 
yes
| ?- 
